/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/* $Source: src/import/chips/p9/procedures/hwp/memory/lib/rosetta_map/rosetta_map.C $ */
/*                                                                        */
/* OpenPOWER HostBoot Project                                             */
/*                                                                        */
/* Contributors Listed Below - COPYRIGHT 2015,2018                        */
/* [+] International Business Machines Corp.                              */
/*                                                                        */
/*                                                                        */
/* Licensed under the Apache License, Version 2.0 (the "License");        */
/* you may not use this file except in compliance with the License.       */
/* You may obtain a copy of the License at                                */
/*                                                                        */
/*     http://www.apache.org/licenses/LICENSE-2.0                         */
/*                                                                        */
/* Unless required by applicable law or agreed to in writing, software    */
/* distributed under the License is distributed on an "AS IS" BASIS,      */
/* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or        */
/* implied. See the License for the specific language governing           */
/* permissions and limitations under the License.                         */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */


///
/// @file rosetta_map.C
/// @brief Mapping tables for memory controller pin names to PHY instance names
/// @note: this file is automatically generated by gen_rosetta_map.pl
///        from input file src_data/DDR_Rosetta_Stone_New.csv
///
// *HWP HWP Owner: Louis Stermole <stermole@us.ibm.com>
// *HWP HWP Backup: Andre Marin <aamarin@us.ibm.com>
// *HWP Team: Memory
// *HWP Level: 3
// *HWP Consumed by: FSP:HB

#include <rosetta_map.H>
#include <lib/phy/dp16.H>

namespace mss
{

// Each pin type has a table of vector<vector<pair>>, indexed by [port][MC c4bit]-->{block, lane}
const rosetta_map::PhyMap rosettaTraits<fapi2::TARGET_TYPE_MCA, DQ>::C4_TO_PHY =
{
    {   {2, 6}, {2, 4}, {2, 5}, {2, 7}, {2, 2}, {2, 0}, {2, 1}, {2, 3}, {4, 6}, {4, 4}, {4, 5}, {4, 7}, {4, 0}, {4, 2}, {4, 1}, {4, 3},
        {3, 4}, {3, 6}, {3, 7}, {3, 5}, {3, 2}, {3, 0}, {3, 1}, {3, 3}, {3, 9}, {3, 11}, {3, 10}, {3, 8}, {3, 13}, {3, 15}, {3, 12}, {3, 14},
        {1, 2}, {1, 0}, {1, 3}, {1, 1}, {1, 5}, {1, 4}, {1, 6}, {1, 7}, {0, 5}, {0, 7}, {0, 4}, {0, 6}, {0, 3}, {0, 1}, {0, 2}, {0, 0},
        {1, 14}, {1, 12}, {1, 15}, {1, 13}, {1, 10}, {1, 8}, {1, 9}, {1, 11}, {0, 13}, {0, 15}, {0, 12}, {0, 14}, {0, 11}, {0, 9}, {0, 10}, {0, 8},
        {2, 14}, {2, 13}, {2, 15}, {2, 12}, {2, 10}, {2, 8}, {2, 11}, {2, 9}
    },
    {   {3, 0}, {3, 1}, {3, 3}, {3, 2}, {3, 4}, {3, 5}, {3, 6}, {3, 7}, {4, 5}, {4, 7}, {4, 6}, {4, 4}, {4, 1}, {4, 2}, {4, 0}, {4, 3},
        {3, 10}, {3, 11}, {3, 9}, {3, 8}, {3, 13}, {3, 15}, {3, 12}, {3, 14}, {2, 6}, {2, 4}, {2, 7}, {2, 5}, {2, 1}, {2, 0}, {2, 3}, {2, 2},
        {1, 6}, {1, 4}, {1, 7}, {1, 5}, {1, 0}, {1, 2}, {1, 3}, {1, 1}, {1, 11}, {1, 9}, {1, 8}, {1, 10}, {1, 15}, {1, 13}, {1, 14}, {1, 12},
        {0, 15}, {0, 13}, {0, 12}, {0, 14}, {0, 9}, {0, 11}, {0, 8}, {0, 10}, {0, 1}, {0, 3}, {0, 2}, {0, 0}, {0, 7}, {0, 5}, {0, 4}, {0, 6},
        {2, 15}, {2, 14}, {2, 13}, {2, 12}, {2, 9}, {2, 10}, {2, 8}, {2, 11}
    },
    {   {4, 4}, {4, 6}, {4, 7}, {4, 5}, {4, 0}, {4, 2}, {4, 3}, {4, 1}, {3, 10}, {3, 8}, {3, 11}, {3, 9}, {3, 13}, {3, 15}, {3, 14}, {3, 12},
        {3, 4}, {3, 6}, {3, 5}, {3, 7}, {3, 0}, {3, 2}, {3, 1}, {3, 3}, {2, 3}, {2, 1}, {2, 2}, {2, 0}, {2, 5}, {2, 7}, {2, 6}, {2, 4},
        {0, 1}, {0, 3}, {0, 0}, {0, 2}, {0, 5}, {0, 7}, {0, 4}, {0, 6}, {2, 15}, {2, 13}, {2, 12}, {2, 14}, {2, 10}, {2, 8}, {2, 11}, {2, 9},
        {1, 15}, {1, 13}, {1, 12}, {1, 14}, {1, 11}, {1, 8}, {1, 9}, {1, 10}, {0, 11}, {0, 9}, {0, 8}, {0, 10}, {0, 13}, {0, 15}, {0, 12}, {0, 14},
        {1, 0}, {1, 2}, {1, 1}, {1, 3}, {1, 4}, {1, 6}, {1, 5}, {1, 7}
    },
    {   {4, 0}, {4, 2}, {4, 3}, {4, 1}, {4, 4}, {4, 6}, {4, 5}, {4, 7}, {2, 0}, {2, 2}, {2, 1}, {2, 3}, {2, 4}, {2, 6}, {2, 7}, {2, 5},
        {3, 9}, {3, 11}, {3, 8}, {3, 10}, {3, 15}, {3, 13}, {3, 14}, {3, 12}, {2, 11}, {2, 9}, {2, 10}, {2, 8}, {2, 13}, {2, 15}, {2, 14}, {2, 12},
        {0, 8}, {0, 10}, {0, 9}, {0, 11}, {0, 12}, {0, 14}, {0, 13}, {0, 15}, {0, 5}, {0, 7}, {0, 6}, {0, 4}, {0, 1}, {0, 3}, {0, 0}, {0, 2},
        {1, 10}, {1, 8}, {1, 11}, {1, 9}, {1, 12}, {1, 14}, {1, 15}, {1, 13}, {1, 4}, {1, 6}, {1, 5}, {1, 7}, {1, 0}, {1, 2}, {1, 1}, {1, 3},
        {3, 2}, {3, 0}, {3, 1}, {3, 3}, {3, 6}, {3, 4}, {3, 7}, {3, 5}
    },
    {   {4, 2}, {4, 0}, {4, 3}, {4, 1}, {4, 6}, {4, 4}, {4, 5}, {4, 7}, {3, 6}, {3, 4}, {3, 7}, {3, 5}, {3, 0}, {3, 2}, {3, 3}, {3, 1},
        {3, 9}, {3, 11}, {3, 8}, {3, 10}, {3, 15}, {3, 13}, {3, 14}, {3, 12}, {2, 4}, {2, 6}, {2, 7}, {2, 5}, {2, 0}, {2, 2}, {2, 1}, {2, 3},
        {1, 2}, {1, 0}, {1, 3}, {1, 1}, {1, 5}, {1, 4}, {1, 6}, {1, 7}, {0, 5}, {0, 7}, {0, 4}, {0, 6}, {0, 3}, {0, 1}, {0, 2}, {0, 0},
        {1, 14}, {1, 12}, {1, 15}, {1, 13}, {1, 10}, {1, 8}, {1, 9}, {1, 11}, {0, 13}, {0, 15}, {0, 14}, {0, 12}, {0, 11}, {0, 9}, {0, 10}, {0, 8},
        {2, 8}, {2, 9}, {2, 11}, {2, 10}, {2, 13}, {2, 15}, {2, 12}, {2, 14}
    },
    {   {2, 4}, {2, 6}, {2, 7}, {2, 5}, {2, 0}, {2, 2}, {2, 1}, {2, 3}, {3, 1}, {3, 3}, {3, 0}, {3, 2}, {3, 5}, {3, 7}, {3, 6}, {3, 4},
        {4, 2}, {4, 0}, {4, 3}, {4, 1}, {4, 4}, {4, 6}, {4, 5}, {4, 7}, {2, 13}, {2, 15}, {2, 14}, {2, 12}, {2, 8}, {2, 11}, {2, 10}, {2, 9},
        {1, 5}, {1, 7}, {1, 6}, {1, 4}, {1, 0}, {1, 2}, {1, 1}, {1, 3}, {1, 13}, {1, 15}, {1, 14}, {1, 12}, {1, 11}, {1, 9}, {1, 10}, {1, 8},
        {0, 10}, {0, 8}, {0, 9}, {0, 11}, {0, 12}, {0, 14}, {0, 13}, {0, 15}, {0, 1}, {0, 3}, {0, 0}, {0, 2}, {0, 7}, {0, 5}, {0, 4}, {0, 6},
        {3, 11}, {3, 9}, {3, 10}, {3, 8}, {3, 13}, {3, 15}, {3, 14}, {3, 12}
    },
    {   {3, 13}, {3, 15}, {3, 14}, {3, 12}, {3, 9}, {3, 11}, {3, 8}, {3, 10}, {2, 4}, {2, 6}, {2, 7}, {2, 5}, {2, 2}, {2, 0}, {2, 3}, {2, 1},
        {4, 4}, {4, 6}, {4, 7}, {4, 5}, {4, 0}, {4, 2}, {4, 3}, {4, 1}, {3, 2}, {3, 0}, {3, 3}, {3, 1}, {3, 6}, {3, 4}, {3, 7}, {3, 5},
        {0, 4}, {0, 6}, {0, 7}, {0, 5}, {0, 0}, {0, 2}, {0, 3}, {0, 1}, {0, 14}, {0, 12}, {0, 15}, {0, 13}, {0, 10}, {0, 8}, {0, 11}, {0, 9},
        {2, 12}, {2, 14}, {2, 15}, {2, 13}, {2, 10}, {2, 8}, {2, 11}, {2, 9}, {1, 7}, {1, 4}, {1, 5}, {1, 6}, {1, 1}, {1, 0}, {1, 3}, {1, 2},
        {1, 15}, {1, 13}, {1, 12}, {1, 14}, {1, 9}, {1, 11}, {1, 8}, {1, 10}
    },
    {   {3, 3}, {3, 1}, {3, 2}, {3, 0}, {3, 7}, {3, 5}, {3, 4}, {3, 6}, {4, 1}, {4, 3}, {4, 0}, {4, 2}, {4, 7}, {4, 5}, {4, 6}, {4, 4},
        {3, 9}, {3, 11}, {3, 10}, {3, 8}, {3, 15}, {3, 13}, {3, 12}, {3, 14}, {2, 7}, {2, 5}, {2, 4}, {2, 6}, {2, 1}, {2, 3}, {2, 2}, {2, 0},
        {1, 14}, {1, 12}, {1, 13}, {1, 15}, {1, 8}, {1, 10}, {1, 9}, {1, 11}, {0, 4}, {0, 6}, {0, 7}, {0, 5}, {0, 0}, {0, 2}, {0, 3}, {0, 1},
        {0, 14}, {0, 12}, {0, 15}, {0, 13}, {0, 8}, {0, 10}, {0, 9}, {0, 11}, {1, 2}, {1, 3}, {1, 0}, {1, 1}, {1, 4}, {1, 7}, {1, 6}, {1, 5},
        {2, 11}, {2, 9}, {2, 10}, {2, 8}, {2, 13}, {2, 15}, {2, 12}, {2, 14}
    }
};

// Each pin type has a table of vector<vector<pair>>, indexed by [port][MC c4bit]-->{block, lane}
const rosetta_map::PhyMap rosettaTraits<fapi2::TARGET_TYPE_MCA, DQS>::C4_TO_PHY =
{
    {   {2, 18}, {4, 18}, {3, 18}, {3, 20}, {1, 16}, {0, 18}, {1, 22}, {0, 22}, {2, 22}, {2, 16}, {4, 16}, {3, 16}, {3, 22}, {1, 18}, {0, 16}, {1, 20},
        {0, 20}, {2, 20}
    },
    {   {3, 16}, {4, 18}, {3, 20}, {2, 18}, {1, 18}, {1, 20}, {0, 22}, {0, 16}, {2, 22}, {3, 18}, {4, 16}, {3, 22}, {2, 16}, {1, 16}, {1, 22}, {0, 20},
        {0, 18}, {2, 20}
    },
    {   {4, 18}, {3, 20}, {3, 18}, {2, 16}, {0, 16}, {2, 22}, {1, 22}, {0, 20}, {1, 16}, {4, 16}, {3, 22}, {3, 16}, {2, 18}, {0, 18}, {2, 20}, {1, 20},
        {0, 22}, {1, 18}
    },
    {   {4, 16}, {2, 16}, {3, 20}, {2, 20}, {0, 20}, {0, 18}, {1, 20}, {1, 18}, {3, 16}, {4, 18}, {2, 18}, {3, 22}, {2, 22}, {0, 22}, {0, 16}, {1, 22},
        {1, 16}, {3, 18}
    },
    {   {4, 16}, {3, 18}, {3, 20}, {2, 18}, {1, 16}, {0, 18}, {1, 22}, {0, 22}, {2, 20}, {4, 18}, {3, 16}, {3, 22}, {2, 16}, {1, 18}, {0, 16}, {1, 20},
        {0, 20}, {2, 22}
    },
    {   {2, 18}, {3, 16}, {4, 16}, {2, 22}, {1, 18}, {1, 22}, {0, 20}, {0, 16}, {3, 20}, {2, 16}, {3, 18}, {4, 18}, {2, 20}, {1, 16}, {1, 20}, {0, 22},
        {0, 18}, {3, 22}
    },
    {   {3, 22}, {2, 18}, {4, 18}, {3, 16}, {0, 18}, {0, 22}, {2, 22}, {1, 18}, {1, 22}, {3, 20}, {2, 16}, {4, 16}, {3, 18}, {0, 16}, {0, 20}, {2, 20},
        {1, 16}, {1, 20}
    },
    {   {3, 16}, {4, 16}, {3, 20}, {2, 18}, {1, 22}, {0, 18}, {0, 22}, {1, 16}, {2, 20}, {3, 18}, {4, 18}, {3, 22}, {2, 16}, {1, 20}, {0, 16}, {0, 20},
        {1, 18}, {2, 22}
    }
};

// Each pin type has a table of vector<vector<pair>>, indexed by [port][MC c4bit]-->{block, lane}
const rosetta_map::PhyMap rosettaTraits<fapi2::TARGET_TYPE_MCA, ADDRESS>::C4_TO_PHY =
{
    {   {0, 8}, {2, 5}, {1, 10}, {2, 4}, {2, 6}, {2, 3}, {2, 9}, {2, 7}, {2, 2}, {2, 8}, {0, 5}, {3, 1}, {2, 11}, {1, 0}, {0, 1}, {0, 11},
        {2, 1}, {1, 4}
    },
    {   {0, 8}, {2, 5}, {1, 10}, {2, 4}, {2, 6}, {2, 3}, {2, 9}, {2, 7}, {2, 2}, {2, 8}, {0, 5}, {3, 1}, {2, 11}, {1, 0}, {0, 1}, {0, 11},
        {2, 1}, {1, 4}
    },
    {   {0, 8}, {2, 5}, {1, 10}, {2, 4}, {2, 6}, {2, 3}, {2, 9}, {2, 7}, {2, 2}, {2, 8}, {0, 5}, {3, 1}, {2, 11}, {1, 0}, {0, 1}, {0, 11},
        {2, 1}, {1, 4}
    },
    {   {0, 8}, {2, 5}, {1, 10}, {2, 4}, {2, 6}, {2, 3}, {2, 9}, {2, 7}, {2, 2}, {2, 8}, {0, 5}, {3, 1}, {2, 11}, {1, 0}, {0, 1}, {0, 11},
        {2, 1}, {1, 4}
    },
    {   {0, 8}, {2, 5}, {1, 10}, {2, 4}, {2, 6}, {2, 3}, {2, 9}, {2, 7}, {2, 2}, {2, 8}, {0, 5}, {3, 1}, {2, 11}, {1, 0}, {0, 1}, {0, 11},
        {2, 1}, {1, 4}
    },
    {   {0, 8}, {2, 5}, {1, 10}, {2, 4}, {2, 6}, {2, 3}, {2, 9}, {2, 7}, {2, 2}, {2, 8}, {0, 5}, {3, 1}, {2, 11}, {1, 0}, {0, 1}, {0, 11},
        {2, 1}, {1, 4}
    },
    {   {0, 8}, {2, 5}, {1, 10}, {2, 4}, {2, 6}, {2, 3}, {2, 9}, {2, 7}, {2, 2}, {2, 8}, {0, 5}, {3, 1}, {2, 11}, {1, 0}, {0, 1}, {0, 11},
        {2, 1}, {1, 4}
    },
    {   {0, 8}, {2, 5}, {1, 10}, {2, 4}, {2, 6}, {2, 3}, {2, 9}, {2, 7}, {2, 2}, {2, 8}, {0, 5}, {3, 1}, {2, 11}, {1, 0}, {0, 1}, {0, 11},
        {2, 1}, {1, 4}
    }
};

// Each pin type has a table of vector<vector<pair>>, indexed by [port][MC c4bit]-->{block, lane}
const rosetta_map::PhyMap rosettaTraits<fapi2::TARGET_TYPE_MCA, CLOCK>::C4_TO_PHY =
{
    {   {1, 3}, {1, 2}, {1, 7}, {1, 6}
    },
    {   {1, 3}, {1, 2}, {1, 7}, {1, 6}
    },
    {   {1, 3}, {1, 2}, {1, 7}, {1, 6}
    },
    {   {1, 3}, {1, 2}, {1, 7}, {1, 6}
    },
    {   {1, 3}, {1, 2}, {1, 7}, {1, 6}
    },
    {   {1, 3}, {1, 2}, {1, 7}, {1, 6}
    },
    {   {1, 3}, {1, 2}, {1, 7}, {1, 6}
    },
    {   {1, 3}, {1, 2}, {1, 7}, {1, 6}
    }
};

// Each pin type has a table of vector<vector<pair>>, indexed by [port][MC c4bit]-->{block, lane}
const rosetta_map::PhyMap rosettaTraits<fapi2::TARGET_TYPE_MCA, WE>::C4_TO_PHY =
{
    {   {0, 1}
    },
    {   {0, 1}
    },
    {   {0, 1}
    },
    {   {0, 1}
    },
    {   {0, 1}
    },
    {   {0, 1}
    },
    {   {0, 1}
    },
    {   {0, 1}
    }
};

// Each pin type has a table of vector<vector<pair>>, indexed by [port][MC c4bit]-->{block, lane}
const rosetta_map::PhyMap rosettaTraits<fapi2::TARGET_TYPE_MCA, RAS>::C4_TO_PHY =
{
    {   {2, 1}
    },
    {   {2, 1}
    },
    {   {2, 1}
    },
    {   {2, 1}
    },
    {   {2, 1}
    },
    {   {2, 1}
    },
    {   {2, 1}
    },
    {   {2, 1}
    }
};

// Each pin type has a table of vector<vector<pair>>, indexed by [port][MC c4bit]-->{block, lane}
const rosetta_map::PhyMap rosettaTraits<fapi2::TARGET_TYPE_MCA, CAS>::C4_TO_PHY =
{
    {   {0, 11}
    },
    {   {0, 11}
    },
    {   {0, 11}
    },
    {   {0, 11}
    },
    {   {0, 11}
    },
    {   {0, 11}
    },
    {   {0, 11}
    },
    {   {0, 11}
    }
};

// Each pin type has a table of vector<vector<pair>>, indexed by [port][MC c4bit]-->{block, lane}
const rosetta_map::PhyMap rosettaTraits<fapi2::TARGET_TYPE_MCA, CS>::C4_TO_PHY =
{
    {   {0, 0}, {1, 1}, {2, 0}, {1, 9}
    },
    {   {0, 0}, {1, 1}, {2, 0}, {1, 9}
    },
    {   {0, 0}, {1, 1}, {2, 0}, {1, 9}
    },
    {   {0, 0}, {1, 1}, {2, 0}, {1, 9}
    },
    {   {0, 0}, {1, 1}, {2, 0}, {1, 9}
    },
    {   {0, 0}, {1, 1}, {2, 0}, {1, 9}
    },
    {   {0, 0}, {1, 1}, {2, 0}, {1, 9}
    },
    {   {0, 0}, {1, 1}, {2, 0}, {1, 9}
    }
};

// Each pin type has a table of vector<vector<pair>>, indexed by [port][MC c4bit]-->{block, lane}
const rosetta_map::PhyMap rosettaTraits<fapi2::TARGET_TYPE_MCA, CKE>::C4_TO_PHY =
{
    {   {3, 3}, {2, 10}, {3, 6}, {3, 4}
    },
    {   {3, 3}, {2, 10}, {3, 6}, {3, 4}
    },
    {   {3, 3}, {2, 10}, {3, 6}, {3, 4}
    },
    {   {3, 3}, {2, 10}, {3, 6}, {3, 4}
    },
    {   {3, 3}, {2, 10}, {3, 6}, {3, 4}
    },
    {   {3, 3}, {2, 10}, {3, 6}, {3, 4}
    },
    {   {3, 3}, {2, 10}, {3, 6}, {3, 4}
    },
    {   {3, 3}, {2, 10}, {3, 6}, {3, 4}
    }
};

// Each pin type has a table of vector<vector<pair>>, indexed by [port][MC c4bit]-->{block, lane}
const rosetta_map::PhyMap rosettaTraits<fapi2::TARGET_TYPE_MCA, ODT>::C4_TO_PHY =
{
    {   {0, 10}, {0, 6}, {0, 9}, {0, 2}
    },
    {   {0, 10}, {0, 6}, {0, 9}, {0, 2}
    },
    {   {0, 10}, {0, 6}, {0, 9}, {0, 2}
    },
    {   {0, 10}, {0, 6}, {0, 9}, {0, 2}
    },
    {   {0, 10}, {0, 6}, {0, 9}, {0, 2}
    },
    {   {0, 10}, {0, 6}, {0, 9}, {0, 2}
    },
    {   {0, 10}, {0, 6}, {0, 9}, {0, 2}
    },
    {   {0, 10}, {0, 6}, {0, 9}, {0, 2}
    }
};

// Each pin type has a table of vector<vector<pair>>, indexed by [port][MC c4bit]-->{block, lane}
const rosetta_map::PhyMap rosettaTraits<fapi2::TARGET_TYPE_MCA, BA>::C4_TO_PHY =
{
    {   {0, 7}, {0, 4}
    },
    {   {0, 7}, {0, 4}
    },
    {   {0, 7}, {0, 4}
    },
    {   {0, 7}, {0, 4}
    },
    {   {0, 7}, {0, 4}
    },
    {   {0, 7}, {0, 4}
    },
    {   {0, 7}, {0, 4}
    },
    {   {0, 7}, {0, 4}
    }
};

// Each pin type has a table of vector<vector<pair>>, indexed by [port][MC c4bit]-->{block, lane}
const rosetta_map::PhyMap rosettaTraits<fapi2::TARGET_TYPE_MCA, BG>::C4_TO_PHY =
{
    {   {3, 2}, {3, 5}
    },
    {   {3, 2}, {3, 5}
    },
    {   {3, 2}, {3, 5}
    },
    {   {3, 2}, {3, 5}
    },
    {   {3, 2}, {3, 5}
    },
    {   {3, 2}, {3, 5}
    },
    {   {3, 2}, {3, 5}
    },
    {   {3, 2}, {3, 5}
    }
};

// Each pin type has a table of vector<vector<pair>>, indexed by [port][MC c4bit]-->{block, lane}
const rosetta_map::PhyMap rosettaTraits<fapi2::TARGET_TYPE_MCA, CID>::C4_TO_PHY =
{
    {   {0, 3}, {1, 5}, {1, 8}
    },
    {   {0, 3}, {1, 5}, {1, 8}
    },
    {   {0, 3}, {1, 5}, {1, 8}
    },
    {   {0, 3}, {1, 5}, {1, 8}
    },
    {   {0, 3}, {1, 5}, {1, 8}
    },
    {   {0, 3}, {1, 5}, {1, 8}
    },
    {   {0, 3}, {1, 5}, {1, 8}
    },
    {   {0, 3}, {1, 5}, {1, 8}
    }
};

// Each pin type has a table of vector<vector<pair>>, indexed by [port][MC c4bit]-->{block, lane}
const rosetta_map::PhyMap rosettaTraits<fapi2::TARGET_TYPE_MCA, ACTN>::C4_TO_PHY =
{
    {   {3, 0}
    },
    {   {3, 0}
    },
    {   {3, 0}
    },
    {   {3, 0}
    },
    {   {3, 0}
    },
    {   {3, 0}
    },
    {   {3, 0}
    },
    {   {3, 0}
    }
};

// Map from MC index to PHY pin. Not a PhyMap because it's the same for every port
const std::vector<std::pair<uint64_t, uint64_t>> rosettaTraits<fapi2::TARGET_TYPE_MCA, DQ>::MC_TO_PHY =
{
    {0, 0}, {0, 1}, {0, 2}, {0, 3}, {0, 4}, {0, 5}, {0, 6}, {0, 7}, {0, 8}, {0, 9}, {0, 10}, {0, 11}, {0, 12}, {0, 13}, {0, 14}, {0, 15},
    {1, 0}, {1, 1}, {1, 2}, {1, 3}, {1, 4}, {1, 5}, {1, 6}, {1, 7}, {1, 8}, {1, 9}, {1, 10}, {1, 11}, {1, 12}, {1, 13}, {1, 14}, {1, 15},
    {2, 0}, {2, 1}, {2, 2}, {2, 3}, {2, 4}, {2, 5}, {2, 6}, {2, 7}, {2, 8}, {2, 9}, {2, 10}, {2, 11}, {2, 12}, {2, 13}, {2, 14}, {2, 15},
    {3, 0}, {3, 1}, {3, 2}, {3, 3}, {3, 4}, {3, 5}, {3, 6}, {3, 7}, {3, 8}, {3, 9}, {3, 10}, {3, 11}, {3, 12}, {3, 13}, {3, 14}, {3, 15},
    {4, 0}, {4, 1}, {4, 2}, {4, 3}, {4, 4}, {4, 5}, {4, 6}, {4, 7},
};

// Map from MC index to PHY pin. Not a PhyMap because it's the same for every port
const std::vector<std::pair<uint64_t, uint64_t>> rosettaTraits<fapi2::TARGET_TYPE_MCA, DQS>::MC_TO_PHY =
{
    {0, 16}, {0, 20}, {1, 16}, {1, 20}, {2, 16}, {2, 20}, {3, 16}, {3, 20}, {4, 16}, {0, 18}, {0, 22}, {1, 18}, {1, 22}, {2, 18}, {2, 22}, {3, 18},
    {3, 22}, {4, 18},
};

namespace rosetta_map
{

///
/// @brief Given a memory controller DQ pin index, return the PHY DP16 instance and lane
/// @tparam T fapi2 Target Type - derived
/// @param[in] i_target the fapi2 target of the port
/// @param[in] i_mc_pin the index of the memory controller pin
/// @param[out] o_dp the DP instance
/// @param[out] o_lane the lane index
/// @return FAPI2_RC_SUCCESS iff ok
///
template<>
fapi2::ReturnCode mc_to_phy<DQ>( const fapi2::Target<fapi2::TARGET_TYPE_MCA>& i_target,
                                 const uint64_t i_mc_pin,
                                 uint64_t& o_dp,
                                 uint64_t& o_lane )
{
    FAPI_ASSERT(i_mc_pin < MAX_DQ_BITS,
                fapi2::MSS_MC_PIN_OUT_OF_RANGE()
                .set_MCA_TARGET(i_target)
                .set_INDEX(i_mc_pin),
                "%s Memory controller pin type DQ, index %d is beyond maximum value %d", mss::c_str(i_target), i_mc_pin,
                (MAX_DQ_BITS - 1) );

    o_dp   = i_mc_pin / BITS_PER_DP;
    o_lane = i_mc_pin % BITS_PER_DP;

    FAPI_INF("%s MC DQ pin %d maps to PHY DP%d lane %d", mss::c_str(i_target), i_mc_pin, o_dp, o_lane);

    return fapi2::FAPI2_RC_SUCCESS;

fapi_try_exit:
    return fapi2::current_err;
}

///
/// @brief Given a PHY DP16 instance and lane, return the corresponding memory controller DQ pin index
/// @tparam T fapi2 Target Type - derived
/// @param[in] i_target the fapi2 target of the port
/// @param[in] i_dp the DP instance
/// @param[in] i_lane the lane index
/// @param[out] o_mc_pin the index of the memory controller pin
/// @return FAPI2_RC_SUCCESS iff ok
///
template<>
fapi2::ReturnCode phy_to_mc<DQ>( const fapi2::Target<fapi2::TARGET_TYPE_MCA>& i_target,
                                 const uint64_t i_dp,
                                 const uint64_t i_lane,
                                 uint64_t& o_mc_pin )
{
    typedef mss::dp16Traits<fapi2::TARGET_TYPE_MCA> TT;

    // DP4 has fewer DQ than the others
    constexpr uint64_t BITS_ON_DP4 = 8;
    const uint64_t l_num_dq = (i_dp == TT::DP_COUNT - 1) ? BITS_ON_DP4 : BITS_PER_DP;

    FAPI_ASSERT((i_dp < TT::DP_COUNT) && (i_lane < l_num_dq),
                fapi2::MSS_NO_MC_PIN_MAPPING()
                .set_MCA_TARGET(i_target)
                .set_DP(i_dp)
                .set_LANE(i_lane),
                "%s No memory controller pin mapping found for type DQ, DP %d, lane %d", mss::c_str(i_target), i_dp, i_lane );

    o_mc_pin = (i_dp * BITS_PER_DP) + i_lane;

    FAPI_INF("%s PHY DP%d lane %d maps to MC DQ pin %d", mss::c_str(i_target), i_dp, i_lane, o_mc_pin);

    return fapi2::FAPI2_RC_SUCCESS;

fapi_try_exit:
    return fapi2::current_err;
}

} // ns rosetta_map

} // ns mss
